
# basic constants and parameters
cmpc = 3.0856776e+18
mH = 1.6605387e-24
E_0 = 1e51
rho_0 = 1.3 * mH
gamma = 5/3.


# r_sf (from fit) enables to determine t
r_sf = 9.77e19
#r_sf = 1.152 * (E_0 / rho_0)**(1/5.) * t**(2/5.)
t = (r_sf * 0.868 * (E_0 / rho_0)**(-1/5.))**(5/2.)

# now we can determine all post-shock quantities
v_sf = 2/5. * 1.152 * (E_0 / rho_0)**(1/5.) * t**(-3/5.)

rho_2 = (gamma+1)/(gamma-1) * rho_0
v_2 = 2./(gamma+1) * v_sf
p_2 = 2./(gamma+1) * rho_0 * v_sf**2


print "t = ", t
print "v_sf = ",  v_sf
print "rho_2 = ", rho_2
print "v_2 = ", v_2
print "p_2 = ", p_2

set terminal postscript eps enhanced solid 20
set xrange [:35]
set xlabel "r [pc]"

set yrange [0:6]
set ylabel "{/Symbol r} [m_{H} cm^{-3}]"
set output "sed_rho.eps"
plot "zud0064ca" using ($1/cmpc):($4/mH) t "ZEUS" \
   , "sedov.dat" using ($2*r_sf/cmpc):($3*rho_2/mH) t "Sedov" w l

   
set yrange [0:110]
set ylabel "v [km s^{-1}]"
set output "sed_v.eps"
plot "zud0064ca" using ($1/cmpc):($6/1e5) t "ZEUS" \
   , "sedov.dat" using ($2*r_sf/cmpc):($4*v_2/1e5) t "Sedov" w l


set yrange [:3.1e-10]
set ylabel "p [dyne cm^{-2}]"
set output "sed_p.eps"
plot "zud0064ca" using ($1/cmpc):((gamma-1)*$5) t "ZEUS" \
   , "sedov.dat" using ($2*r_sf/cmpc):($5*p_2) t "Sedov" w l




