#!/bin/csh
#
# merge.s [-d <DIRECTORY> ] [-m <MAKEFILE>] [-e <EXECUTABLE>] 
#         [-l <LIBRARIES>] <CHANGE_DECK> <SOURCE_CODE>
#
# Uses the EDITOR executable xedit22 to merge the change deck <CHANGE_DECK>
# into the source code <SOURCE_CODE>.
#
#======= SCRIPT FILE TO MERGE A CHANGE DECK INTO A SOURCE CODE ========#
#
# Set defaults
#
set SOURCE_CODE  = "$argv[$#argv]"
set DIRECTORY    = "${SOURCE_CODE}.dir"
set MAKEFILE     = "${SOURCE_CODE}.make"
set EXECUTABLE   = "${SOURCE_CODE}.x"
set LIBRARIES    = ""
#
# Check for options on the command line; set CHANGE_DECK.
#
while ($#argv > 1)
  switch ($1)
  case -d:
    set DIRECTORY = "$1"
    breaksw
  case -m:
    set MAKEFILE = "$1"
    breaksw
  case -l:
    set LIBRARIES = "$1"
    breaksw
  case -e:
    set EXECUTABLE = "$1"
    breaksw
  default:
    set CHANGE_DECK = "$1"
    breaksw
  endsw
  shift
end
#
#======================> If necessary, create the directory "DIRECTORY".
if (! -e $DIRECTORY) mkdir $DIRECTORY
#--------------------------------------------------> Create change deck.
\rm -f changes
cat << EOF > changes
**id,changes
**def UNICOS
*read $CHANGE_DECK
EOF
#-----------------------> Create the input deck for EDITOR, and execute.
\rm -f inedit
cat << EOF > inedit
 \$editpar   inname='$SOURCE_CODE'
          , ibanner=1, job=3, idump=1, inum=0, ipre=1, inmlst=1
          , chgdk='changes'
          , iutask=0, iupdate=1, ext='.f', branch='$DIRECTORY'
          , makename='$MAKEFILE', xeq='$EXECUTABLE'
          , libs='$LIBRARIES' \$
EOF
chmod 700 xedit22
xedit22
