#!/bin/csh
#
# split.s [-d <DIRECTORY> ] <SOURCE_CODE>
#
# Uses the EDITOR executable xedit22 to split the source code 
# <SOURCE_CODE> into separate files.
#
#==== SCRIPT FILE TO SPLIT A SOURCE CODE INTO FILES FOR EACH DECK =====#
#
# Set defaults
#
set SOURCE_CODE  = "$argv[$#argv]"
set DIRECTORY    = "${SOURCE_CODE}.dir"
#
# Check for options on the command line.
#
if ("$1" == "-d") set DIRECTORY = "$2"
#
#======================> If necessary, create the directory "DIRECTORY".
if (! -e $DIRECTORY) mkdir $DIRECTORY
#
#-----------------------> Create the input deck for EDITOR, and execute.
\rm -f inedit
cat << EOF > inedit
 \$editpar   inname='$SOURCE_CODE'
          , ibanner=1, job=6, idump=1
          , ext='.f', branch='$DIRECTORY' \$
EOF
chmod 700 xedit22
xedit22
