#!/bin/csh
#
# target.s [-f <FIRST> ] [-s <SECOND>] [-c <FIRST_CD>] \
#          [-k <FIRST_DK>]  <SOURCE_CODE>
#
# Uses the EDITOR executable xedit22 to tidy up the source code 
# <SOURCE_CODE>.
#
#============ SCRIPT FILE TO TIDY UP FORTRAN SOURCE CODE ==============#
#
# Set defaults
#
set SOURCE_CODE  = "$argv[$#argv]"
#
# Check for options on the command line.
#
while ($#argv > 1)
  switch ($1)
  case -f:
    set FIRST = "$1"
    breaksw
  case -s:
    set SECOND = "$1"
    breaksw
  case -c:
    set FIRST_CD = "$1"
    breaksw
  case -k:
    set FIRST_DK = "$1"
    breaksw
  default:
    breaksw
  endsw
  shift
end
#
#-----------------------> Create the input deck for EDITOR, and execute.
\rm -f inedit
cat << EOF > inedit
 \$editpar   inname='$SOURCE_CODE'
          , ibanner=1, job=2, idump=1
          , ibegdo=  10, ienddo= 990, ibegre=1010, iendre=1990
          , ibegwr=2010, iendwr=2990
          , inc=10, irepl=1, ireseq=1, indent=2, ialpha=1
          , first='$FIRST', secnd='$SECOND', firstcd='$FIRST_CD'
          , firstdk='$FIRST_DK' \$
EOF
chmod 700 xedit22
xedit22
