#============== SOURCE FILE TO CREATE THE ZEUS EXECUTABLE =============#
#
#  The "mssget" script file is in /u/ncsa/dclarke/util/unitree
#
#==============================================> Get files from UNITREE.
if(! -e zeus32) mssget /u/ncsa/dclarke/zeus3d/source/version3.2 zeus32
if(! -e zeus32.mac) mssget /u/ncsa/dclarke/zeus3d/xeq/version3.2/uy zeus32.mac
#if(! -e chgz32) mssget /u/ncsa/dclarke/zeus3d/source/version3.2 chgz32
if(! -e xedit21) mssget /u/ncsa/dclarke/editor/xeq/version2.1/uy xedit21
if(! -e namelist.lib) mssget /u/ncsa/dclarke/editor/xeq/namelist/uy namelist.lib
if(! -e cfiles.lib) mssget /u/ncsa/dclarke/zeus3d/cfiles/uy cfiles.lib
if(! -e ncar.lib) mssget /u/ncsa/dclarke/libr/ncar/uy ncar.lib
#========================> If necessary, create the directory "zeus3.2".
if(! -e zeus3.2) mkdir zeus3.2
#----------------------------------------------> Create the change deck.
rm chgzeus
cat << EOF > chgzeus
*read zeus32.mac
*d par.17,18
       parameter     ( in   =  21, jn   =  21, kn   =  21, ijkn =  21 )
       parameter     ( nxpx =  16, nypx =  16, nxrd =  20, nyrd =  20 )
*i shkset.9999
*dk yuden
       subroutine yuden
*ca rouse
       integer       i       , j, k
       real          d0  
       external      bndyall
c-----------------------------------------------------------------------
       namelist / pgen     / d0
       d0 = 1.0
       read (ioin, pgen)
       if (iolog .gt. 0) write (iolog, pgen)
c
         do 40 k=ks,ke
           do 30 j=js,je
             do 20 i=is,ie
               d (i,j,k) = sin ( pi/float(nx1z) * (x1b(i)-x1a(is)))
     1                   * sin ( pi/float(nx2z) * (x2b(j)-x2a(js)))
     1                   * sin ( pi/float(nx3z) * (x3b(k)-x3a(ks)))
               d (i,j,k) = d0 * ( 1.0 + 0.01*d(i,j,k) )
20           continue
30         continue
40       continue
c
       call bndyall
       return
       end
EOF
#=======================> Create the input deck for EDITOR, and execute.
rm inedit
cat << EOF > inedit
 \$editpar   inname='zeus32'
          , ibanner=0, idump=1, job=3, safety=0.20
          , ipre=1, inmlst=1, iupdate=1, iutask=0
          , chgdk='chgzeus'
          , branch='zeus3.2'
          , makename='makezeus', xeq='xzeus32', loader='ncargf77'
          , compiler='cft77 -M0726'
          , coptions='-ez -o off'
c         , compiler='cf77'
c         , coptions='-c -Zp -Wf"-M0726 -eP"'
          , libs='-lsci namelist.lib cfiles.lib ncar.lib -ldf -limsl'  \$
EOF
xedit21
#--------------------------------------> Create the input deck for ZEUS.
rm inzeus
cat << EOF > inzeus
 \$iocon    iotty=6, iolog=2                                            \$
 \$rescon   dtdmp=80.0, id='xd', resfile='zr00xd'                       \$
 \$ggen1    nbl=16, x1min=0.0, x1max=16.0, igrid=1, x1rat=1.0
         , lgrid=.t.                                                   \$
 \$ggen2    nbl=16, x2min=0.0, x2max=16.0, igrid=1, x2rat=1.0
         , lgrid=.t.                                                   \$
 \$ggen3    nbl=16, x3min=0.0, x3max=16.0, igrid=1, x3rat=1.0
         , lgrid=.t.                                                   \$
 \$pcon     nlim= 1, tlim=80.0, ttotal=900.0, tsave=10.0           \$
 \$edcon                                                                \$
 \$hycon    qcon=2.0, qlin=0.0, courno=0.5, iord=2, istp=0              \$
 \$iib      niib(1:21,1:21)=2                                         \$
 \$oib      noib(1:21,1:21)=2                                         \$
 \$ijb      nijb(1:21,1:21)=2                                         \$
 \$ojb      nojb(1:21,1:21)=2                                         \$
 \$ikb      nikb(1:21,1:21)=2                                         \$
 \$okb      nokb(1:21,1:21)=2                                         \$
 \$grvcon                                                               \$
 \$eqos                                                                 \$
 \$gcon                                                                 \$
 \$extcon                                                               \$
 \$sscon                                                                \$
 \$plt1con  iplt1dir=1,2,3,3, dtplt1=1.0, iplt1=0,11,11,4, corl=1
         , jplt1=11,0,11,5, kplt1=11,11,0,0, plt1var= 'd ', 'gp'      \$
 \$plt2con                                                              \$
 \$pixcon                                                               \$
 \$voxcon  dtvox=1.0, voxvar='d ','gp'                             \$
 \$usrcon                                                               \$
 \$hdfcon                                                               \$
 \$tslcon                                                               \$
 \$discon                                                               \$
 \$radcon                                                               \$
 \$pgen     d0=1.0                                                    \$
EOF
#============================================> MAKE the ZEUS executable.
make -f makezeus
#====================> Gather up all compiler messages into single file.
rm  zeus32.l
cat zeus3.2/*.l > zeus32.l
rm  zeus3.2/*.l
