#============== SOURCE FILE TO CREATE THE ZEUS EXECUTABLE =============#
#
#==============================================> Get files from UNITREE.
if(! -e zeus32) mssget /u/ncsa/dclarke/zeus3d/source/version3.2 zeus32
if(! -e zeus32.mac) mssget /u/ncsa/dclarke/zeus3d/xeq/version3.2/chandra zeus32.mac
if(! -e chgz32) mssget /u/ncsa/dclarke/zeus3d/source/version3.2 chgz32
if(! -e xedit21) mssget /u/ncsa/dclarke/editor/xeq/version2.1/chandra xedit21
if(! -e namelist.lib) mssget /u/ncsa/dclarke/editor/xeq/namelist/chandra namelist.lib
if(! -e checkin.o) mssget /u/ncsa/dclarke/zeus3d/cfiles/chandra checkin.o
if(! -e ncar.libo) mssget /u/ncsa/dclarke/libr/ncar/chandra ncar.libo
if(! -e sci.lib) mssget /u/ncsa/dclarke/libr/scilib/chandra sci.lib
#========================> If necessary, create the directory "zeus3.2".
if(! -e zeus3.2) mkdir zeus3.2
#----------------------------------------------> Create the change deck.
rm chgzeus
cat << EOF > chgzeus
*read zeus32.mac
*d par.14,15
       parameter     ( in   = 805, jn   =   1, kn   =   1, ijkn = 805 )
       parameter     ( nxpx =   1, nypx =   1, nxrd =   1, nyrd =   1 )
**read chgz32
EOF
#=======================> Create the input deck for EDITOR, and execute.
rm inedit
cat << EOF > inedit
 \$editpar   inname='zeus32'
          , ibanner=0, idump=1, job=3, safety=0.20
          , ipre=1, inmlst=1, iupdate=1, iutask=0
          , chgdk='chgzeus'
          , branch='zeus3.2'
          , makename='makezeus', xeq='xzeus32'
          , coptions='-Nq1000 -Nl39 -O3'
          , libs='namelist.lib checkin.o ncar.libo sci.lib -ldf -lncarg
  -lncarg_gks -lncarg_loc'                                             \$
EOF
chmod 700 xedit21
xedit21
#--------------------------------------> Create the input deck for ZEUS.
rm inzeus
cat << EOF > inzeus
 \$iocon    iotty=6, iolog=2                                            \$
 \$rescon   dtdmp=80.0, id='xd', resfile='zr00xd'                       \$
 \$ggen1    nbl=800, x1min=0.0, x1max=800.0, igrid=1, x1rat=1.0
         , lgrid=.t.                                                   \$
 \$ggen2    nbl=001, x2min=0.0, x2max=  1.0, igrid=1, x2rat=1.0
         , lgrid=.t.                                                   \$
 \$ggen3    nbl=001, x3min=0.0, x3max=  1.0, igrid=1, x3rat=1.0
         , lgrid=.t.                                                   \$
 \$pcon     nlim= 999999, tlim=80.0, ttotal=900.0, tsave=10.0           \$
 \$hycon    qcon=2.0, qlin=0.0, courno=0.5, iord=2, istp=0, itote=0     \$
 \$iib      niib(1:1  ,1:1  )=2                                         \$
 \$oib      noib(1:1  ,1:1  )=2                                         \$
 \$ijb      nijb(1:1  ,1:805)=2                                         \$
 \$ojb      nojb(1:1  ,1:805)=2                                         \$
 \$ikb      nikb(1:805,1:1  )=2                                         \$
 \$okb      nokb(1:805,1:1  )=2                                         \$
 \$grvcon                                                               \$
 \$eqos     gamma=2.0                                                   \$
 \$gcon                                                                 \$
 \$extcon                                                               \$
 \$plt1con  iplt1dir=1, dtplt1=80.0
         , plt1var= 'd ', 'se', 'p ', 'v1', 'v2', 'v3', 'b1', 'b2'
                  , 'b3', 'bd'                                         \$
 \$plt2con                                                              \$
 \$pixcon                                                               \$
 \$voxcon                                                               \$
 \$usrcon                                                               \$
 \$hdfcon                                                               \$
 \$tslcon                                                               \$
 \$discon                                                               \$
 \$radcon                                                               \$
 \$pgen     idirect=1, n0=400, d0=1.000, e0=1.0, v10=0.0, b10=0.75
         , b20=0.6, b30=0.8                                            \$
 \$pgen     idirect=1, n0=400, d0=0.125, e0=0.8, v10=0.0, b10=0.75
         , b20=-0.6, b30=-0.8                                          \$
EOF
#============================================> MAKE the ZEUS executable.
make -f makezeus
